﻿:Class supdate
⍝  Script update

    ⎕IO←1 ⋄ ⎕ML←1

    ∇ r←List
      :Access Shared Public
      r←⎕NS ⍬
    ⍝ Name, group, short description and parsing rules
      r.(Name Group Parse)←'supdate' 'wsutils' '1s -DONTSAVE'
      r.Desc←'Update object script with new objects'
    ∇
    
    If←/⍨

    ∇ r←Run(Cmd Args);obj;ref;src;ns;new;cl;var;v;cs;f;top;del;space;SALT;hasSALT;SALTcopy
      :Access Shared Public
      :Select Cmd
      :Case 'supdate'
          ref←space←##.THIS
          :If 0<⍴Args.Arguments
              'invalid object'⎕SIGNAL 11 If 9≠space.⎕NC obj←1⊃Args.Arguments
              ref←space⍎obj           ⍝ this is the object we're dealing with
          :EndIf
          'Cannot update # or ⎕SE'⎕SIGNAL 11 If ref∊# ⎕SE
          :If hasSALT←9=ref.⎕NC SALT←'SALT_Data' ⋄ SALTcopy←ref⍎SALT ⋄ :EndIf
          obj←ref.⎕NL ¯2.1 ¯3 ¯4  ⍝ and all the visible names in it
          src←⎕SRC ref            ⍝ the source
          ns←0 ⎕FIX src           ⍝ refixed w/o the new objects
          new←obj~ns.⎕NL-2.1 3 4  ⍝ the added material
          :If 0=⍴new
              r←'No new object found'
          :Else
              var←2=⌊cl←ref.⎕NC new    ⍝ and their classes
         ⍝ Find the top lines of the source
              top←⍴src←{(+/∧\' '=⍵)↓⍵}¨src
              top←⍴r←src↑⍨v-top=v←+/∧\' :⍝'∊⍨⍬∘⍴¨src
         ⍝ Load the conversion software
              cs←⎕SE.SALT.Load'lib\NStoScript -noname'
         ⍝ Add the new vars
              :If ∨/var
                  r,←(var/new)cs.makeVars ref
              :EndIf
         ⍝ Add body of source
              r,←¯1↓top↓src ⍝ keep :endspace
         ⍝ Add the new fns
              :If ∨/f←~var
                  del←0.1=1|f/cl
                  r,←⊃,/del{c←ref.⎕NR ⍵ ⋄ c[⍳⍺],⍨←'∇' ⋄ ' ',c,⍺/'∇'}¨f/new
              :EndIf
         ⍝ Add last line
              r,←¯1↑src
         ⍝ Refix space
              ref←space.⎕FIX r
              (v f)←0<ns←+/1 0∘.=var
              r←'Added ',(v/' variables',⍨⍕1↑ns),(' and '/⍨v∧f),f/' functions',⍨⍕1↓ns
              :If hasSALT
                  ref.SALT_Data←SALTcopy
                  ⎕SE.SALT.Save ref
              :EndIf
          :EndIf
      :EndSelect
    ∇

    ∇ r←Help Cmd;⎕ML;CR
      :Access Shared Public
      ⎕ML←1 ⋄ CR←⎕UCS 13 133∩⎕AVU
      :Select Cmd
      :Case 'supdate'
          r←'Update the script of classes and namespaces by adding new functions at the bottom',CR
          r,←'and variables at the top.',CR
          r,←'Note that the script WILL BE saved with SALT if already SALTed unless -DONTSAVE is supplied.'
      :EndSelect
    ∇

:EndClass